<?php

namespace Drupal\ironstar\EventSubscriber;

use Drupal\Core\Messenger\MessengerInterface;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\HttpKernel\Event\RequestEvent;
use Symfony\Component\HttpKernel\KernelEvents;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpKernel\Event\ResponseEvent;

class FastlyEventSubscriber implements EventSubscriberInterface {

  protected $messenger;

  public function __construct(MessengerInterface $messenger) {
    $this->messenger = $messenger;
  }

  public static function getSubscribedEvents() {
    return [
      KernelEvents::REQUEST => 'onKernelRequest',
      // KernelEvents::RESPONSE => 'onResponse',
    ];
  }

  public function onKernelRequest(RequestEvent $event) {
    $route_name = \Drupal::routeMatch()->getRouteName();

    $target_routes = [
      'fastly.settings',
      'fastly.edge_modules',
      'fastly.settings.image_optimizer',
    ];

    if (in_array($route_name, $target_routes)) {
      $this->messenger->addMessage(t('Since the Ironstar module is enabled, some features are locked. Please manage your Fastly configuration in the Ironstar Console', ['@route' => $route_name]));
    }
  }

}
