<?php

namespace Drupal\ironstar\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

/**
 * Listens to the dynamic route events.
 */
class FastlyRouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    if ($route = $collection->get('fastly.edge_modules')) {
      $route->setDefault('_controller', '\Drupal\ironstar\Routing\FastlyRouteSubscriber::noFunction');
    }
    if ($route = $collection->get('fastly.settings.image_optimizer')) {
      $route->setDefault('_controller', '\Drupal\ironstar\Routing\FastlyRouteSubscriber::noFunction');
    }
  }

  /**
   * Returns a "nothing here" message to replace controllers which are not to be accessed with Ironstar module installed.
   *
   * return []
   */
  public function noFunction() {
    $build = [
      '#markup' => t('This feature is managed through the Ironstar Console.'),
    ];
    return $build;
  }

}
